config/routes.rb
Rails.application.routes.draw do

  root 'index#index'

  devise_for :users, controllers: { sessions: 'users/sessions', omniauth_callbacks: 'omniauth_callbacks' }
  
  devise_for :admin, controllers: { sessions: 'admin/sessions' }
  
  devise_for :scores
  
  get 'admin/index'
  
  get 'users/scores'
  
  match 'scores/copy/:id' => 'scores#copy', via: [:post], :as => :copy
  
  match '/users/:id/finish_signup' => 'users#finish_signup', via: [:get, :patch], :as => :finish_signup
  
  resources :users do
    member do
      get :download_score
    end
  end
  
  resources :scores do
    member do
      put :convert
      put :unshare
      put :share
    end
  end
  

end

app/models/score.rb
class Score < ApplicationRecord
    belongs_to :user
    mount_uploader :attachment, ScoreUploader

end

app/controllers/scores_controller.rb
class ScoresController < ApplicationController
    include ConverterHelper

    before_action :authenticate_user!, if: :login, :except => [:index]

    def index
        @user = current_user
        @scores = Score.where('share' => true, 'copied' => false).find_each 
    end

    def show
        @score = Score.find(params[:id])
        if (user_signed_in? && (current_user.id == @score.user_id)) || !(:login)
            @parsed = JSON.parse(@score.score_hash)
            render 'show'
        elsif (user_signed_in? && (current_user.id != @score.user_id))
            redirect_to current_user
        end
    end

    def create
        @score = Score.new(score_params)
        @score.user_id = current_user.id

        if @score.save
            redirect_to users_scores_path, notice: "The score #{@score.name} has been uploaded."
        else
            redirect_to users_scores_path, notice: "Not saved"
        end
    end
    
    def destroy
        @user = current_user
        @score = Score.find(params[:id])
        @score.destroy
        redirect_to users_scores_path, notice: "The score #{@score.name} has been deleted."
    end

    def share
        @score = Score.find(params[:id])
        if @score.update(share: true)
            redirect_to users_scores_path
        end
    end
    
    def unshare
        @score = Score.find(params[:id])
        if @score.update(share: false)
            redirect_to users_scores_path
        end
    end
    
    def copy
        @score1 = Score.find(params[:id])
        @score = Score.new
        @score.user_id = current_user.id
        @score.name = @score1.name
        @score.attachment = @score1.attachment
        @score.uploaded_by = @score1.uploaded_by
        @score.copied = true
        
        if @score.save
            redirect_to users_scores_path
        end
    end
        
    def convert
        @score = Score.find(params[:id])
        if (user_signed_in? && (current_user.id == @score.user_id)) || !(:login)
            @new_hash = analyse(@score.attachment)
            @json_hash = JSON.generate(@new_hash)
            @score.update(score_hash: @json_hash)
            redirect_to @score
        elsif (user_signed_in? && (current_user.id != @score.user_id))
            redirect_to current_user
        end
    end
        
    private
    
    def score_params
      params.require(:score).permit(:name, :attachment, :share, :uploaded_by, :copied)
    end

    def login
      warden = env['warden']
        !(warden.authenticated?(:admin))
    end

end

app/views/scores/_details_modal.html.erb
<% if @parsed %>
<!DOCTYPE html>
<html>
<head>
<style>
.modal-header {
    padding: 2px 16px;
    background-color: #5cb85c;
    color: white;
}
body {
  position: relative;
}
</style>
</head>

<body data-spy="scroll" data-target="#navbar-target">
<div class="modal fade in" tabindex="-1" role="dialog" id="details">
 
 <div class="modal-dialog">
        <div class="modal-header">
            
          <div class="container-fluid">
            <div class="row">
              <div class="col-md-12"><h2 class="modal-title">Measure details</h2></div>
            </div>
          </div>
          
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>

        </div>

        <div class="container">
            <div class="modal-body">
                <nav class="navbar navbar-expand-lg navbar-light bg-faded">
                  <div class="collapse navbar-collapse" id="navbarNavDropdown">
                    <ul class="navbar-nav">
                      <% for index in 0..(@parsed.length) %>
                        <% staff = 0 %>
                        <% @length = 2 %>
                        <% if @parsed[index].is_a? String %>
                          <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="<%= @parsed[index] %>" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                              <%= @parsed[index] %>
                            </a>
                            <% index += 1 %>
                            <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                              <% if @parsed[index].is_a? Array %>
                                <% @parsed[index].select{|x, y| x == @parsed[index - 1]}.each_with_index do |instrument, i| %>
                                  <% if instrument.length == 2 %>
                                    <% @length = 2 %>
                                  <% elsif instrument.length == 6 %>
                                    <% if @length == 2 && instrument[1][1] != staff %>
                                      <% staff = instrument[1][1] %>
                                      <a class="dropdown-item" href="#section1", onclick="return false;" >Staff <%= instrument[1][1] %></a>
                                      <% @length = 6 %>
                                    <% end %>
                                  <% end %>
                                <% end %>
                              <% end %>
                            </div>
                          </li>
                        <% end %>
                      <% end %>
                    </ul>
                  </div>
                </nav>
                <div class="jumbotron">
                  <div id="navbar-target">
                  <% @length = 2 %>
                  <% @parsed.each_with_index do |row, index| %>
                    <% if row.is_a? String %>
                      <div class="row">
                        <div class="col-4"><h3><%= row %></h3></div>
                      </div>
                    <% end %>
                    <% if row.is_a? Array %>
                      <% row.select{|x, y| x == @parsed[index - 1]}.each_with_index do |instrument, i|%>
                        <% if instrument.length == 2 %>
                          <% @length = 2 %></br>
                        <% elsif instrument.length == 6 %>
                          <div id="section1" class="row">
                            <div class="col-3"><% if @length == 2 %>Staff <%= instrument[1][1] %><% end %></div>
                            <div class="col-9"><% if instrument[5] != nil %>At measure <%= instrument[5][2] %> : <%= instrument[5][3][0] %> / <%= instrument[5][3][1] %><% end %></div>
                          </div>
                          <% @length = 6 %>
                        <% end %>
                      <% end %>
                    <% end %>
                  <% end %>
                </div>
                </div>
            </div>
        </div>
    </div>
</div>

</body>
</html>
<% end %>

app/views/scores/_new_modal.html.erb
<!DOCTYPE html>
<html>
<head>
<style>
.modal-header {
    padding: 2px 16px;
    background-color: #5cb85c;
    color: white;
}
</style>
</head>

<body>
    
<div class="modal fade in" tabindex="-1" role="dialog" id="new">
 
 <div class="modal-dialog">
        <div class="modal-header">
            
          <div class="container-fluid">
            <div class="row">
              <div class="col-md-12"><h2 class="modal-title">Upload score (MSCX file)</h2></div>
            </div>
          </div>
          
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>

        </div>

        <%= form_for Score.new, html: { multipart: true } do |f| %>
            
            <div class="container">
                <div class="modal-body">
                
                    <div>
                        <%= f.label :name %></br>
                        <%= f.text_field :name %>
                    </div>
                    <div>
                        </br><%= f.label :attachment %></br>
                        <%= f.file_field :attachment %>
                    </div>
                    <div>
                        </br><%= f.label :uploaded_by %></br>
                        <% if user_signed_in? %>
                            <%= f.text_field :uploaded_by, value: current_user.first_name %>
                        <% else %>
                            <%= f.text_field :uploaded_by, value: "Guest"%>
                        <% end %>
                    </div>
                    <div>
                        </br><%= f.label :share %>
                        <%= f.check_box :share, {}, true, false %>
                    </div>
                    <div>
                        </br><%= f.submit "Upload" %>
                    </div>
                </div>
            </div>
        <% end %>
    </div>
</div>

</body>
</html>

app/views/scores/index.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Public scores</title>
  </head>

  <body>
    <div class="container">
      <div class="jumbotron">
         <h1>Publicly shared scores</h1>
         
         <div class="row">
            <div class="col-3"><h3>Score name</h3></div>
            <div class="col-3"><h3>Composer name</h3></div>
        </div>
        
        <% @scores.each do |score| %>
            <div class="row">
                <div class="col-3"><%= score.name %></div>
                <div class="col-3"><%= score.uploaded_by %></div>
                <div class="col-3"><span class="copy-score"><%= link_to "Add to my scores", copy_path(score), :method => :post %></span></div>

            </div>
        <% end %>
        
      </div>

    </div><!-- /.container -->
  </body>
</html>

app/views/scores/share.js.erb
$('.share-score').html('share');

app/views/scores/show.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title><%= @score.name %></title>
  </head>

  <body>
    <div class="container">
      <div class="jumbotron">
        <h1><%= @score.name %></h1>
          <% @length = 2 %>
          <% @parsed.each_with_index do |row, index| %>
            <% if row.is_a? String %>
              <div class="row">
                <div class="col-2"><h3><%= row %></h3></div>
                <div class="col-2"><h3>Clef</h3></div>
                <div class="col-2"><h3>Time signature</h3></div>
                <div class="col-2"><h3>Key signature</h3></div>
                <div class="col-2"><h3>Measure details</h3></div>
                <div class="col-2"><h3>Instrument convention</h3></div>
                </br>
              </div>
            <% elsif row.is_a? Array %>
              <% row.select{|x, y| x == @parsed[index - 1]}.each_with_index do |instrument, i|%>
                <% if instrument.length == 2 %>
                  <% @convention = instrument %>
                  <% @length = 2 %>
                <% elsif instrument.length == 6 %>
                  <div class="row">
                    <div class="col-2"><% if @length == 2 %>Staff <%= instrument[1][1] %><% end %></div>
                    <div class="col-2"><% if instrument[1] != nil %>At measure <%= instrument[1][2] %> : <%= instrument[1][3] %><% end %></div>
                    <div class="col-2"><% if instrument[2] != nil %>At measure <%= instrument[2][2] %> : <%= instrument[2][3][0] %> / <%= instrument[2][3][1] %><% end %></div>
                    <div class="col-2"><% if instrument[3] != nil %>At measure <%= instrument[3][2] %> : <%= instrument[3][3] %><% end %></div>
                    <div class="col-2"><% if @length == 2 %><%= link_to "Click here", "#details", "data-toggle" => "modal" %><% end %></div>
                    <div class="col-2"><% if @length == 2 %>Range : <%= @convention[1][1] %> to <%= @convention[1][2] %><% end %></div>
                  </div>
                <% @length = 6 %>
                <% end %>
              <% end %>
            <% end %>
          <% end %>
      </div>
    </div><!-- /.container -->
  </body>
</html>

app/views/scores/unshare.js.erb
$('.unshare-score').html('unshare');